;https://www.purebasic.fr/english/viewtopic.php?t=39485
IncludeFile "writeiconfile.pbi" ; or srod's SaveIcon.pbi ;)

Global *token, *image

If OpenLibrary(0, "gdiplus.dll") = 0
  MessageRequester("Error","Required component gdiplus.dll is not found. Please install it and retry    ", #MB_ICONERROR)
  End
EndIf

Prototype GdiplusStartup( *token, *input, mode ) 
Prototype GdipCreateBitmapFromFile(*filename, *image)
Prototype GdipCreateHICONFromBitmap(*image, hIcon.i)
Prototype GdipDisposeImage( *image ) 
Prototype GdiplusShutdown( *token ) 

Global Startup.GdiplusStartup                          = GetFunction( 0, "GdiplusStartup" )          
Global CreateBitmapFromFile.GdipCreateBitmapFromFile   = GetFunction( 0, "GdipCreateBitmapFromFile" ) 
Global CreateHICONFromBitmap.GdipCreateHICONFromBitmap = GetFunction( 0, "GdipCreateHICONFromBitmap") 
Global DisposeImage.GdipDisposeImage                   = GetFunction( 0, "GdipDisposeImage" )        
Global Shutdown.GdiplusShutdown                        = GetFunction( 0, "GdiplusShutdown" )  

CompilerIf Defined(GdiplusStartupInput, #PB_Structure) = 0
  Structure GdiplusStartupInput 
    GdiPlusVersion.l 
    *DebugEventCallback.Debug_Event
    SuppressBackgroundThread.l 
    SuppressExternalCodecs.l 
  EndStructure 
CompilerEndIf  

Procedure InitGDIPlus()
  input.GdiplusStartupInput
  input\GdiPlusVersion = 1
  input\DebugEventCallback = #Null
  input\SuppressBackgroundThread = #False
  input\SuppressExternalCodecs = #False
  Startup( @*token, @input, #Null)
EndProcedure

Procedure ShutdownGDIPlus()
  Shutdown(*token)
  CloseLibrary(0)
EndProcedure

pattern$ = "PNG, BMP, JPEG, TIFF|*.png;*.bmp;*.jpg;*.jpeg;*.tiff|PNG (*.png)|*.png|BMP (*.bmp)|*.bmp|JPEG (*.jpg)|*.jpg|TIFF (*.tif)|*.tif"
inpath$ = OpenFileRequester("Choose an image to convert to icon:","",pattern$, 0)
prompt$ = RemoveString(GetFilePart(inpath$),"."+GetExtensionPart(inpath$))
prompt$ +".ico"
If FileSize(inpath$) < 1
  MessageRequester("Info:","No file selected. Ending...",#MB_ICONINFORMATION)
  End
EndIf

InitGDIPlus()

inUnicode$ = Space(Len(inpath$)*2+2)
PokeS(@inUnicode$, inpath$, -1, #PB_Unicode) 
inpath_as_bstr = SysAllocString_(@inUnicode$) 

pattern$ = "ICON (*.ico)|*.ico;"
outpath$ = SaveFileRequester("Choose a path to save the .ico file:",prompt$,pattern$, 0)
outpath$ = RemoveString(outpath$, ".ico")
outpath$ + ".ico"

CreateBitmapFromFile(inpath_as_bstr, @*image)
CreateHICONFromBitmap(*image, @hIcon.i)
DisposeImage(*image)
ShutdownGDIPlus()

If WriteIconFile(@hIcon, 1, outpath$)
  MessageRequester("Info:", "Icon successfully saved to " + outpath$, #MB_ICONINFORMATION)
  DeleteObject_(hIcon)
EndIf

; IDE Options = PureBasic 5.72 (Windows - x64)
; Folding = -
; EnableXP